<script setup>
////////////////////////////////
// IMPORT
////////////////////////////////

import { useNotificationStore } from "@/stores/useNotificationStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  notification: {
    type: Object,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["menuOpen"]);

////////////////////////////////
// STORE
////////////////////////////////

const notificationStore = useNotificationStore();
const workspaceStore = useWorkspaceStore();

////////////////////////////////
// FUNCTIONS
////////////////////////////////

function getIconRead() {
  if (props.notification.unread) {
    return "mdi-checkbox-marked-outline";
  } else {
    return "mdi-checkbox-blank-badge-outline";
  }
}
function getIconArchived() {
  if (props.notification.archived) {
    return "mdi-archive-arrow-up-outline";
  } else {
    return "mdi-archive-outline";
  }
}

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => workspaceStore.currentWid,
  async (newValue) => {
    if (newValue) {
      await notificationStore.fetchNotifications();
    }
  },
);
</script>

<template>
  <div style="width: 100%" :class="{ 'opacity-50': !notification.unread }">
    <v-sheet class="ma-1 divNotification">
      <v-sheet class="d-flex mb-1">
        <img
          :src="getGravatar(notification.actorObject.email, 24)"
          alt=""
          style="border-radius: 50%; margin: 0; padding: 0; height: 24px !important"
          class="mx-1 mt-1"
          @click="notificationStore.markAsRead(notification.id)"
        >

        <!------------------------------------------------------------------------------
        NODE
        ------------------------------------------------------------------------------->
        <p
          v-if="notification.actionObject.obj === 'node'"
          class="me-auto"
          @click="notificationStore.markAsRead(notification.id)"
        >
          <b>{{ notification.actorObject.fullName }}</b>
          {{ notification.verb }}
          <span v-if="notification.verb === 'created'"> a new </span>

          <span v-if="notification.actionObject.obj === 'node'">{{
            notification.actionObject.extraInfo
          }}</span>
          <span v-else>{{ notification.actionObject.obj }}</span>
          <br>
          <span class="text-caption ms-1">{{ notification.timestamp }}</span>
          <br>

          <!--           Action object        -->
          The new
          <NuxtLink
            v-if="notification.actionObject.obj === 'node'"
            :to="`/${workspaceStore.currentWSlug}/${notification.actionObject.id}`"
            class="text-decoration-none font-weight-black text-black"
            @click="emits('menuOpen', false)"
          >
            {{ notification.actionObject.extraInfo }}
          </NuxtLink>

          <span v-else> {{ notification.actionObject.obj }} </span>
          <!--           / Action object        -->
          is in the

          <!--           Target object        -->
          <span v-if="notification.targetObject.obj === 'node'">
            {{ notification.targetObject.extraInfo }}
          </span>
          <span v-else> {{ notification.targetObject.obj }} </span>

          <NuxtLink
            v-if="notification.targetObject.obj === 'node'"
            :to="`/${workspaceStore.currentWSlug}/${notification.targetObject.id}`"
            class="ms-1 text-decoration-none font-weight-black text-black"
            @click="emits('menuOpen', false)"
          >
            {{ notification.targetObject.name }}
          </NuxtLink>

          <span v-else class="font-italic">{{ notification.targetObject.name }}</span>
          <!--          / Target object        -->
        </p>

        <!------------------------------------------------------------------------------
        MEMBER
        ------------------------------------------------------------------------------->
        <p
          v-if="notification.actionObject.obj === 'node member'"
          class="me-auto"
          @click="notificationStore.markAsRead(notification.id)"
        >
          <b>{{ notification.actorObject.fullName }}</b>

          <span v-if="notification.verb === 'created'">
            added you in {{ addArticle(notification.targetObject.extraInfo) }}</span>
          <span v-if="notification.verb === 'changed'">
            changed your role in {{ addArticle(notification.targetObject.extraInfo) }}
          </span>
          <span v-if="notification.verb === 'suppressed'">
            removed you from {{ addArticle(notification.targetObject.extraInfo) }}</span>

          <br>
          <span class="text-caption ms-1">{{ notification.timestamp }}</span>
          <br>

          <!--           Action object        -->
          <span v-if="notification.verb === 'created'">You have been added to the </span>
          <span v-if="notification.verb === 'changed'">Your role have changed in the </span>
          <span v-if="notification.verb === 'suppressed'">You have been removed from the </span>

          <!--           Target object        -->
          <span v-if="notification.targetObject.obj === 'node'">
            {{ notification.targetObject.extraInfo }}
          </span>
          <span v-else> {{ notification.targetObject.obj }} </span>

          <NuxtLink
            v-if="notification.targetObject.obj === 'node'"
            :to="`/${workspaceStore.currentWSlug}/${notification.targetObject.id}`"
            class="ms-1 text-decoration-none font-weight-black text-black"
            @click="emits('menuOpen', false)"
          >
            {{ notification.targetObject.name }}.
          </NuxtLink>

          <span v-else class="font-italic">{{ notification.targetObject.name }}.</span>
          <span v-if="notification.verb === 'created' && notification.actionObject.extraInfo != null">Your role is {{ notification.actionObject.extraInfo }}
          </span>
          <span v-if="notification.verb === 'changed' && notification.actionObject.extraInfo != null">Your new role is {{ notification.actionObject.extraInfo }}
          </span>

          <!--          / Target object        -->
        </p>

        <!------------------------------------------------------------------------------
        SUBMISSION
        ------------------------------------------------------------------------------->
        <p
          v-if="notification.actionObject.obj === 'submission'"
          class="me-auto"
          @click="notificationStore.markAsRead(notification.id)"
        >
          <b>{{ notification.actorObject.fullName }}</b>
          {{ notification.verb }}
          <span v-if="notification.verb === 'created'"> a new </span>
          <span v-if="notification.verb === 'generated metadata' || notification.verb === 'error generating metadata'"> in </span>
          submission
          <br>
          <span class="text-caption ms-1">{{ notification.timestamp }}</span>
          <br>

          <NuxtLink
            :to="`/${workspaceStore.currentWSlug}/submissions-${notification.targetObject.id}`"
            class="text-decoration-none font-weight-black text-black"
            @click="emits('menuOpen', false)"
          >
            {{ notification.targetObject.name }}
          </NuxtLink>

          <span v-if="notification.actionObject.extraInfo" class="ms-1">
            (Status: {{ notification.actionObject.extraInfo }})
          </span>
        </p>

        <div style="min-width: 50px" class="hideDivIcons">
          <v-icon
            v-if="!notification.archived"
            :icon="getIconRead()"
            @click="notificationStore.changeReadStatus(notification.id)"
          />
          <v-icon
            v-if="notification.archived"
            icon="mdi-trash-can-outline"
            @click="notificationStore.clearANotification(notification.id)"
          />
          <v-icon
            :icon="getIconArchived()"
            @click="notificationStore.changeArchivedStatus(notification.id)"
          />
        </div>
      </v-sheet>
    </v-sheet>
  </div>
</template>

<style>
.hideDivIcons {
  color: white;
}

.divNotification:hover .hideDivIcons {
  color: gray;
}

.opacity-50 {
  opacity: 0.5; /* Opacité de 50% */
}
</style>
